#include<bits/stdc++.h>
#include<windows.h>
#include<tlhelp32.h>
using namespace std;
string filepath;
int filever,curfilever=2,musicleng,curlo;
FILE *file;
struct smusic{
	int start,heig,pitch,leng;
	bool rise;
};
queue <smusic> music;
struct stime{
	int h,min;
	float s;
};
struct stimems{
	time_t s;
	short ms;
};
struct splay{
	int start,end;
	float speed;
	bool yn;
};
stimems gettimems(){
	stimems curtime;
	SYSTEMTIME stime;
	GetLocalTime(&stime);
	curtime.ms=stime.wMilliseconds;
	curtime.s=time(0);
	return curtime;
}
DWORD findproc(LPCTSTR name){
	PROCESSENTRY32 pe;
	DWORD id=0;
	HANDLE hSnapshot=CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,0);
	pe.dwSize=sizeof(PROCESSENTRY32);
	if(!Process32First(hSnapshot,&pe)){
		return 0;
	}
	while(1){
	pe.dwSize=sizeof(PROCESSENTRY32);
	if(Process32Next(hSnapshot,&pe)==FALSE)
		break;
		if(strcmp(pe.szExeFile,name)==0){
			id=pe.th32ProcessID;
			break;
		}
	}
	CloseHandle(hSnapshot);
	return id;
}
int ffile(){
	int ret=0;
	file=fopen(filepath.c_str(),"rb");
	if(file==0){
		ret=-1;
		return ret;
	}
	fseek(file,0,SEEK_SET);
	fread(&filever,sizeof(int),1,file);
	if(filever!=curfilever){
		ret=filever;
	}
	//fread(&mousex,sizeof(int),1,file);
	//fread(&mousey,sizeof(int),1,file);
	//fread(&toplo,sizeof(int),1,file);
	//fread(&leftlo,sizeof(int),1,file);
	fseek(file,4*sizeof(int),SEEK_CUR);
	fread(&musicleng,sizeof(int),1,file);
	while(!music.empty()){
		music.pop();
	}
	smusic mtmp;
	int ext;
	while(1){
		fread(&mtmp.start,sizeof(int),1,file);
		if(mtmp.start==-1){
			break;
		}
		fread(&mtmp.leng,sizeof(int),1,file);
		fread(&mtmp.heig,sizeof(int),1,file);
		fread(&mtmp.pitch,sizeof(int),1,file);
		fread(&mtmp.rise,sizeof(bool),1,file);
		fread(&ext,sizeof(int),1,file);
		fseek(file,ext,SEEK_CUR);
		music.push(mtmp);
	}
	fclose(file);
	return ret;
}
double getfreq(int heig,int pitch,bool rise){
	const int base=45,pth[14]={0,2,4,5,7,9,11,1,3,5,6,8,10,-1};
	const double A3=440,k=1.05946309436;
	if(rise==1){
		pitch+=7;
	}
	int hfs=12*heig+pth[pitch-1]-base;
	double freq=A3*pow(k,hfs);
	//printf("%f",freq);
	return freq;
}
int main(){
	if(findproc("BeepMusic.exe")==0){
		return 1;
	}
	int mode;
	splay play;
	smusic oldmusic,mtmp;
	stimems statime,curtime;
	freopen("beepset.tmp","r",stdin);
	scanf("%d%d%d",&mode,&statime.s,&statime.ms);
	if(mode==0){
		fseek(stdin,2*sizeof(char),SEEK_CUR);
		getline(cin,filepath);
		scanf("%d%d%f",&play.start,&play.end,&play.speed);
		curlo=play.start;
		ffile();
		while(curlo<play.end){
			for(int i=0;i<music.size();i++){
				oldmusic=music.back();
				//printf("%d %d %d",mousex,music.front().start,music.back().start);
				music.push(music.front());
				music.pop();
				if(curlo>=music.back().start&&curlo<music.front().start){
					if(i!=music.size()-1&&(music.back().heig!=oldmusic.heig||music.back().pitch!=oldmusic.pitch||music.back().rise!=oldmusic.rise)){
						mtmp=music.back();
						if(mtmp.rise==1){ 
							mtmp.pitch+=7;
						}
					}
					break;
				}
			}
			curtime=gettimems();
			if(curlo==music.back().start){
				int freq=getfreq(music.back().heig,music.back().pitch,music.back().rise);
				long long playtimems=max(statime.s*1000+statime.ms+long(curlo*100/play.speed)+long(music.back().leng*100/play.speed)-long(play.start*100/play.speed)-curtime.s*1000-curtime.ms,long(0));
				//long long playtimems=music.back().leng*100/play.speed;
				Beep(freq,playtimems);
				curlo+=music.back().leng;
			}
			else{
				curlo++;
				long long sleeptimems=max(statime.s*1000+statime.ms+long(curlo*100/play.speed)-long(play.start*100/play.speed)-curtime.s*1000-curtime.ms,long(0));
				Sleep(sleeptimems);
			}
		}
	}
	fclose(stdin);
	return 0;
}
